// |-------------------------------------------|
// | Antifreeze Hack                           |
// | by: madsiur                               |
// | version: 1.0a                             |
// | released on: Frebruary 12th, 2022         |
// | apply to: FF3us 1.0 (no header)           |
// |-------------------------------------------|

arch snes.cpu

macro seek(variable offset) {
  origin (offset & $3FFFFF)
  base offset
}

// equipment properties setting hook
seek($C2291A)
jsr free_space_a
nop
nop

// monster properties setting hook
seek($C22E24)
jsr free_space_b

// new code
seek($C26469)       // you can change this free space offset as long as it's in bank $C2
free_space_a:
eor $D2             // equipment immunities
sta $331C,x         // make not vulnerable to
lda $D2             // equipment immunities
bit #$0008          // check if the "repel magitek" flag is set
beq exit_a          // exit if not
lda #$FDFF          // not vulnerable to Freeze
sta $3330,x         // make not vulnerable to Freeze
exit_a:
rts

free_space_b:
sta $331C,y         // original code
lda $CF0014,x       // monster blocked status bytes 1-2
bit #$0008          // check if the "block magitek" flag is set
beq exit_b          // exit if not
lda #$FDFF          // not vulnerable to Freeze
and $3330,y
sta $3330,y         // make monster not vulnerable to Freeze
exit_b:
rts